%define i18ndate 20010626
%define patchlevel 33
%define rel 1

Name:		bash
Version:	4.3
Release:	%mkrel %{patchlevel}.%{rel}
Summary:	The GNU Bourne Again shell (bash)
Group:		Shells
License:	GPLv2+
URL:		http://www.gnu.org/software/bash/bash.html
Source0:	ftp://ftp.gnu.org/pub/gnu/bash/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.gnu.org/pub/gnu/bash/%{name}-%{version}.tar.gz.sig
Source2:	ftp://ftp.gnu.org/pub/gnu/bash/bash-doc-3.2.tar.bz2
Source3:	dot-bashrc
Source4:	dot-bash_profile
Source5:	dot-bash_logout
Source6:	alias.sh
Source7:	bashrc-pclos
Source8:	profile.d-bash

# Official upstream patches
# from ftp://ftp.gnu.org/gnu/bash/bash-%{version}-patches/
Patch01:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-001
Patch02:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-002
Patch03:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-003
Patch04:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-004
Patch05:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-005
Patch06:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-006
Patch07:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-007
Patch08:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-008
Patch09:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-009
Patch10:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-010
Patch11:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-011
Patch12:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-012
Patch13:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-013
Patch14:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-014
Patch15:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-015
Patch16:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-016
Patch17:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-017
Patch18:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-018
Patch19:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-019
Patch20:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-020
Patch21:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-021
Patch22:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-022
Patch23:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-023
Patch24:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-024
Patch25:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-025
Patch26:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-026
Patch27:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-027
Patch28:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-028
Patch29:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-029
Patch30:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-030
Patch31:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-031
Patch32:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-032
Patch33:	ftp://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-033


# Patches
Patch1001: bash-2.02-security.patch
Patch1003: bash-4.0-profile.patch
Patch1006: bash-2.04-compat.patch
Patch1020: bash-strcoll-bug.diff
Patch1024: bash-3.2-lzma-copmpletion.patch


BuildRequires:	autoconf2.5
BuildRequires:	bison
BuildRequires:	groff
BuildRequires:	ncurses-devel
BuildRequires:	texinfo
# explicit file provides
Provides:	/bin/sh /usr/bin/sh
Requires:	%{_lib}readline6 >= 6.3
Requires:	%{_lib}ncursesw5
Requires:	glibc >= 2.20

%description
Bash is a GNU project sh-compatible shell or command language
interpreter. Bash (Bourne Again shell) incorporates useful features
from the Korn shell (ksh) and the C shell (csh). Most sh scripts
can be run by bash without modification.

Bash offers several improvements over sh, including command line
editing, unlimited size command history, job control, shell
functions and aliases, indexed arrays of unlimited size and
integer arithmetic in any base from two to 64. Bash is ultimately
intended to conform to the IEEE POSIX P1003.2/ISO 9945.2 Shell and
Tools standard.

%package doc
Summary:	Documentation for the GNU Bourne Again shell (bash)
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description doc
This package provides documentation for GNU Bourne Again shell (bash).

%prep
%setup -q -a 2
mv doc/README .

%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0

%patch1001 -p1 -b .security
%patch1003 -p1 -b .profile
%patch1020 -p1 -b .strcoll_bugx
%patch1024 -p1 -b .lzma


%build

export CFLAGS="%{optflags} -Os"
export CXXFLAGS="$CFLAGS"
export DEBUGGER_START_FILE="%{_datadir}/bashdb/bashdb-main.inc"

%configure2_5x \
    --enable-command-timing \
    --disable-rpath \
    --enable-history \
    --enable-job-control \
    --enable-multibyte \
    --enable-readline \
    --with-installed-readline \
    --without-gnu-malloc \
    --without-bash-malloc \
    --disable-strict-posix-default \
    --enable-select \
    --enable-prompt-string-decoding \
    --enable-process-substitution \
    --enable-alias \
    --enable-bang-history \
    --enable-coprocesses \
    --enable-directory-stack \
    --enable-brace-expansion

%make


%install
rm -rf %buildroot
%makeinstall_std

# beurk
rm -rf %{buildroot}%{_datadir}/locale/en@boldquot/ %{buildroot}%{_datadir}/locale/en@quot/

#Sucks
chmod +w doc/texinfo.tex
chmod 755 examples/misc/aliasconv.*
chmod 755 examples/misc/cshtobash
chmod 755 %{buildroot}%{_bindir}/bashbug

# Take out irritating ^H's from the documentation
mkdir tmp_doc
for i in `/bin/ls doc/` ; \
	do cat doc/$i > tmp_doc/$i ; \
	cat tmp_doc/$i | perl -p -e 's/.//g' > doc/$i ; \
	rm tmp_doc/$i ; \
	done
rmdir tmp_doc

mkdir -p %{buildroot}/bin
( cd %{buildroot} && mv usr/bin/bash bin/bash )
( cd %{buildroot}/bin && ln -s bash sh )

# make builtins.1 and rbash.1 with bash.1 in place (fix mdv#51379)
(cd doc
mkdir tmp_fix_so
cd tmp_fix_so
cp ../builtins.1 ../rbash.1 .
sed -e '/^.if \\n(zZ=1 .ig zZ/,/^.zZ/d' ../bash.1 > bash.1
soelim builtins.1 > ../builtins.1
sed -e '/^.if \\n(zY=1 .ig zY/,/^.zY/d' ../bash.1 > bash.1
soelim rbash.1    > ../rbash.1
)
rm -rf doc/tmp_fix_so

# make manpages for bash builtins as per suggestion in DOC/README
(cd doc
sed -e '
/^\.SH NAME/, /\\- bash built-in commands, see \\fBbash\\fR(1)$/{
/^\.SH NAME/d
s/^bash, //
s/\\- bash built-in commands, see \\fBbash\\fR(1)$//
s/,//g
b
}
d
' builtins.1 | tr -s ' ' '\n' | grep -v -E '^(printf|export|echo|pwd|test|kill)$' > man.pages
# tr is needed because there are few commands in a row separated with a whilespace
# echo,export,kill,printf,pwd,test -- these files are provided by other packages

install -m 644 builtins.1 %{buildroot}%{_mandir}/man1/builtins.1

install -m 644 rbash.1 %{buildroot}%{_mandir}/man1/rbash.1

for i in `cat man.pages` ; do
# install man-page
  echo .so man1/builtins.1 > %{buildroot}%{_mandir}/man1/$i.1

# now turn man.page into a filelist for the man subpackage
  echo "%{_mandir}/man1/$i.1%{_extension}" >> ../man.pages.filelist
done


mkdir -p %{buildroot}%{_sysconfdir}/skel
mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/skel/.bashrc
install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/skel/.bash_profile
install -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/skel/.bash_logout
install -m 644 %{SOURCE6} %{buildroot}%{_sysconfdir}/profile.d/60alias.sh
install -m 644 %{SOURCE7} %{buildroot}%{_sysconfdir}/bashrc
install -m 644 %{SOURCE8} %{buildroot}%{_sysconfdir}/profile.d/95bash-extras.sh

ln -s bash %{buildroot}/bin/rbash

install -m 644 bash.info %{buildroot}%{_infodir}
)

%find_lang %{name}

# merges list
cat man.pages.filelist %{name}.lang > files.list

%posttrans
/sbin/ldconfig


%files -f files.list
%doc README
%config(noreplace) %{_sysconfdir}/skel/.b*
%{_sysconfdir}/profile.d/60alias.sh
%{_sysconfdir}/profile.d/95bash-extras.sh
%{_sysconfdir}/bashrc
/bin/rbash
/bin/bash
/bin/sh
%{_infodir}/bash.info*
%{_mandir}/man1/bash.1*
%{_mandir}/man1/rbash.1*
%{_mandir}/man1/builtins.1*
%{_mandir}/man1/bashbug.1*
%{_bindir}/bashbug

%files doc
%doc COMPAT NEWS NOTES POSIX CHANGES
%doc examples
%doc doc/*.ps doc/*.0 doc/*.html doc/article.txt


%changelog
* Wed Feb 04 2015 bb <bb> 4.3.33.1pclos2015
- update

* Wed Oct 15 2014 bb <bb> 4.3.30.2pclos2014
- rebuild

* Sun Oct 05 2014 bb <bb> 4.3.30.1pclos2014
- update

